CREATE PROCEDURE [dbo].[ArchivingQueryCheck]
AS
BEGIN

DECLARE @PROCESS_SEQ INT = 1,
		@MIN_SEQ INT = 0,
		@MAX_SEQ INT = 0,
		@ROWS BIGINT,
		@QueryToExec NVARCHAR(MAX) = ''

SELECT @MIN_SEQ = MIN(PROCESS_SEQ) FROM TB_M_TABLE_ARCHIVING_CONFIG
SELECT @MAX_SEQ = MAX(PROCESS_SEQ) FROM TB_M_TABLE_ARCHIVING_CONFIG

TRUNCATE TABLE TB_R_TABLE_QUERYCHECKING

SET @PROCESS_SEQ = @MIN_SEQ
WHILE (@PROCESS_SEQ <= @MAX_SEQ)
BEGIN

	IF (EXISTS (SELECT 'x' FROM TB_M_TABLE_ARCHIVING_CONFIG 
					WHERE process_seq = @PROCESS_SEQ 
							AND ISNULL(NULLIF(now_archieving, ''), 'NOT_YET') = 'NOT YET'))
	BEGIN

			INSERT INTO TB_R_TABLE_QUERYCHECKING
			SELECT 
				@PROCESS_SEQ,
				'SELECT @ROWS = COUNT(1) FROM ' + table_name + ' WHERE 1 = 1 ' + 
					CASE ISNULL(process_condition, '') WHEN '' THEN '' ELSE ' AND ' + 
							REPLACE(REPLACE(process_condition, '[archive_range]', convert(varchar(3), ISNULL(archive_range, ''))), '[now_date]', '''' + CAST(CONVERT(DATE, GETDATE()) as VARCHAR(15)) + '''') END as Query,
				0,
				''
			FROM TB_M_TABLE_ARCHIVING_CONFIG WHERE process_seq = @PROCESS_SEQ

		BEGIN TRY
			SELECT @QueryToExec = query FROM TB_R_TABLE_QUERYCHECKING WHERE seq = @PROCESS_SEQ
			EXEC sp_executesql @QueryToExec, N'@ROWS BIGINT OUTPUT', @ROWS OUT

			UPDATE TB_R_TABLE_QUERYCHECKING SET return_rows = @ROWS WHERE seq = @PROCESS_SEQ
		END TRY
		BEGIN CATCH
			UPDATE TB_R_TABLE_QUERYCHECKING SET msg = ERROR_MESSAGE() WHERE seq = @PROCESS_SEQ
		END CATCH
	END
	SET @PROCESS_SEQ = @PROCESS_SEQ + 1
END
END

